#ifndef _ALIGNMENT_H_
#   define _ALIGNMENT_H_

#include <iostream>
using std::ostream;

class Alignment
{
   public:
      typedef enum {
         _LT, _LC, _LB,
         _CT, _CC, _CB,
         _RT, _RC, _RB
      } Type;

      Alignment(Type theType);
      ~Alignment();
      Type get() const;
      friend ostream &operator<<(ostream &, const Alignment &);

   private:
      Alignment(const Alignment &);
      Alignment &operator=(const Alignment &);
      const char *typeAsString() const;
      
      Type mType;
};

#endif
