#ifndef _ATTRIBUTE_VISITOR_H_
#   define _ATTRIBUTE_VISITOR_H_

#include "Visitor.h"

class MessageReceiver;
class AttributeNode;
class BinaryNode;
class ConstantNode;
class DefineNode;
class PropertyNode;
class UnaryNode;

class AttributeVisitor : public Visitor
{
   public:

      AttributeVisitor(MessageReceiver &receiver);
      ~AttributeVisitor();

      void visited(AttributeNode *);
      void visited(BinaryNode *);
      void visited(ConstantNode *);
      void visited(DefineNode *);
      void visited(PropertyNode *);
      void visited(MinMaxNode *);
      void visited(UnaryNode *);

      void setField(Field field);

   private:
      const char *fieldAsString() const;
      MessageReceiver &mReceiver;
};

#endif
