#include "GenericStack.h"

template<class T>
class StackTemplate
{
   public:
      StackTemplate()
         : mPtr(0)
      {
         mPtr = new GenericStack();
      }

      ~StackTemplate()
      {
         while(!isEmpty())
            delete pop();

         delete mPtr;
      }

      int isEmpty() const
      {
         return(mPtr->isEmpty());
      }

      T *top() const
      {
         return((T *)mPtr->top());
      }

      T *pop() const
      {
         return((T *)mPtr->pop());
      }

      void push(T *t)
      {
         mPtr->push((void *)t);
      }

      int size() const
      {
         return(mPtr->size());
      }
      
   private:
      StackTemplate(const StackTemplate<T> &);
      StackTemplate &operator=(const StackTemplate<T> &);
      GenericStack *mPtr;
};
